package cz.zcu.ups.arcaoftpd.dataaction;

import java.io.File;
import java.io.OutputStream;
import java.util.Date;

import cz.zcu.ups.arcaoftpd.ArcaoFTPd;

/**
 * Trida zastresujici datovou akci, ktera vylistuje adresar
 * @author Arcao
 */
public class NlstDataAction extends DataAction {
	/**
	 * Konstriktor tridy s nastaveni parametru cesty k adresari, ktery se bude vylistovavat
	 * @param parameter			cesta
	 */
	public NlstDataAction(String parameter) {
		super(parameter);
	}

	/**
	 * Uporneni klienta, ze bylo otevreno datove spojeni
	 */
	public void preRun() {
		try {
			getClientParameters().sendMessage(150, "Opening data connection for directory list.");
			ArcaoFTPd.getLogger().write(("OD: " + new Date().toString() + "; " + getClientParameters().getSocket().getRemoteSocketAddress().toString() +"; Open data connection...\n").getBytes("utf-8"));
		} catch (Exception e) {
		}
	}

	/**
	 * Vykona proces vylistovani adresare
	 */
	public void run() {
		try {
			OutputStream out = getSocket().getOutputStream();

			File dir = getClientParameters().getUser().translatePathToAbsoluteFile(getParameter());
			// vypiseme vsechny polozky adresare, pokud je polozka typu adresar
			for (String item : dir.list()) {
				File itemFile = new File(dir, item);
				if (itemFile.isDirectory())	out.write((itemFile.getName() + "\r\n").getBytes(getClientParameters().getEncoding()));
			}
			out.close();
			getSocket().close();
			getClientParameters().sendMessage(226, "Transfer ok.");
		} catch(Exception e) {
			try {
				getClientParameters().sendMessage(426, "Connection closed; transfer aborted.");
			} catch (Exception ex) {
			}
			e.printStackTrace();
		}
		try {
			ArcaoFTPd.getLogger().write(("CD: " + new Date().toString() + "; " + getClientParameters().getSocket().getRemoteSocketAddress().toString() +": Close data connection...\n").getBytes("utf-8"));
		} catch (Exception e) {
		}
	}
}